package services;

import dao.*;

/**
 * Classe qui traite les savoir faire 
 * dont l'utilisateur fait appel
 * @author Djimangue
 * @version 2.0 Gestion des Patients
 * 
 */
public class Traitements {
	
	/**
	 * Methode qui permet juste
	 * d'afficher un message de bienvenue
	 */
	public void pageAccueil(){ 
		
		System.out.println ("Bienvenue cher agent d'accueil dans votre application de gestion des patients");
		System.out.println ("Merci de saisir les des donnes du patient");
		
	}
	
	/**
	 * Mthode qui gnre le matricule 
	 * le patient donn en paramtre
	 * @param patient
	 * @return patient.getMatricule()
	 */
	public String genererMatricule(Patient patient){
				
		if(patient.getNom().length()<3){
			patient.setMatricule(patient.getNumTicket()+patient.getNom());			
		}else{
			patient.setMatricule(patient.getNumTicket()+patient.getNom().substring(0,3));
		}
		return patient.getMatricule();
	}
	
	/**
	 * Methode qui retourne le nom du service 
	 * donn en paramtre
	 * @param servicesHp
	 * @return servicesHp.getNomService()
	 * 
	 */
	
	public String serviceSoignant(ServicesHospitaliers servicesHp) {
			switch(servicesHp.getNumService()){
				case 1:
					servicesHp.setNomService("Pdiatrie");				
				break;
				case 2:
					servicesHp.setNomService("Ophtalmologie");	
							
				break;
				case 3:
					servicesHp.setNomService("Gnraliste");
									
				break;
				default:
					servicesHp.setNomService("INEXISTANTE");										
			} 		
		return servicesHp.getNomService();
	}
	
	/**
	 * methode qui retourne le montant de la 
	 * facture consultation donn en paramtre
	 * @param patient
	 * @return facture.getMontantFacture()
	 */
	public Double facturation(Patient patient) {
		Facture facture = new Facture();
		double pourcentage = 0.5 ;
		if(patient.getAge()<18 && patient.getPriseEnCharge()==0){
			facture.setMontantFacture(10000.0);
		}else if(patient.getAge()>=18 && patient.getPriseEnCharge()==0){
			facture.setMontantFacture(20000.0);
		}else if(patient.getPriseEnCharge()==1){
			facture.setMontantFacture(15000*pourcentage);
			System.out.println("Patient bnficiant d'une reduction  cause de sa prise en charge "+'\n');
		}
		return facture.getMontantFacture();
	}

	/**
	 * methode qui affiche les informations
	 * sur le patient donne en paramtre
	 * @param p
	 */
	public void affichePatient(Patient p ){ 
		String[] patient={p.getNumTicket()+"",p.getMatricule(),p.getPrenom(),p.getNom(),p.getAge()+"",
				p.getPriseEnCharge()+"",p.getTelephone()+"",p.getAdresse(),p.getEmail()};
		System.out.println("-----------------------------------");
		System.out.println("--           FICHE PATIENT      --");
		System.out.println("-----------------------------------");
		for(int i=0; i<patient.length; i++){
			System.out.println("--            "+patient[i]);
			System.out.println("-----------------------------------");
		}
	}
}
